"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = HiddenCropper;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _CropImageModal = _interopRequireDefault(require("./CropImageModal"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function HiddenCropper(_ref) {
  var triggerRef = _ref.triggerRef,
      onCropped = _ref.onCropped,
      _ref$cropOptions = _ref.cropOptions,
      cropOptions = _ref$cropOptions === void 0 ? {} : _ref$cropOptions,
      _ref$outputOptions = _ref.outputOptions,
      outputOptions = _ref$outputOptions === void 0 ? {} : _ref$outputOptions,
      _ref$displayOptions = _ref.displayOptions,
      displayOptions = _ref$displayOptions === void 0 ? {} : _ref$displayOptions;
  var inputRef = (0, _react.useRef)();

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      showModal = _useState2[0],
      setShowModal = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      imageFile = _useState4[0],
      setImageFile = _useState4[1];

  var _useState5 = (0, _react.useState)(null),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      cropState = _useState6[0],
      setCropState = _useState6[1];

  function handleFileChange(e) {
    var file = e.target.files[0];

    if (file) {
      setShowModal(true);
      setImageFile(file);
      setCropState(null);
    }
  }

  function handleConfirm(croppedFile) {
    setShowModal(false);
    setImageFile(null);
    setCropState(null);
    onCropped(croppedFile);
  }

  function handleCancel() {
    setShowModal(false);
    setImageFile(null);
    setCropState(null);
  }

  triggerRef.current = {
    trigger: function trigger() {
      inputRef.current.click();
    }
  };
  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("input", {
    ref: inputRef,
    type: "file",
    accept: "image/*",
    value: "",
    onChange: handleFileChange,
    hidden: true
  }), _react["default"].createElement(_CropImageModal["default"], {
    show: showModal,
    imageFile: imageFile,
    value: cropState,
    onChange: setCropState,
    onConfirm: handleConfirm,
    onCancel: handleCancel,
    cropOptions: cropOptions,
    outputOptions: outputOptions,
    displayOptions: _objectSpread({}, displayOptions, {
      showRemoveButton: false
    })
  }));
}